Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -4554,18 +4606,18 @@
 !--    Upward-facing surfaces
        DO  m = 1, bc_h(0)%ns
-          i = bc_h(0)%i(m)            
-          j = bc_h(0)%j(m)
-          k = bc_h(0)%k(m)
-          u(k-1,j,i) = 0.0_wp
-          v(k-1,j,i) = 0.0_wp
+          ic = bc_h(0)%i(m)            
+          jc = bc_h(0)%j(m)
+          kc = bc_h(0)%k(m)
+          u(kc-1,jc,ic) = 0.0_wp
+          v(kc-1,jc,ic) = 0.0_wp
        ENDDO
 !
 !--    Downward-facing surfaces
        DO  m = 1, bc_h(1)%ns
-          i = bc_h(1)%i(m)            
-          j = bc_h(1)%j(m)
-          k = bc_h(1)%k(m)
-          u(k+1,j,i) = 0.0_wp
-          v(k+1,j,i) = 0.0_wp
+          ic = bc_h(1)%i(m)            
+          jc = bc_h(1)%j(m)
+          kc = bc_h(1)%k(m)
+          u(kc+1,jc,ic) = 0.0_wp
+          v(kc+1,jc,ic) = 0.0_wp
        ENDDO
     ENDIF
@@ -4574,16 +4626,16 @@
 !-- Upward-facing surfaces
     DO  m = 1, bc_h(0)%ns
-       i = bc_h(0)%i(m)            
-       j = bc_h(0)%j(m)
-       k = bc_h(0)%k(m)
-       w(k-1,j,i) = 0.0_wp
+       ic = bc_h(0)%i(m)            
+       jc = bc_h(0)%j(m)
+       kc = bc_h(0)%k(m)
+       w(kc-1,jc,ic) = 0.0_wp
     ENDDO
 !
 !-- Downward-facing surfaces
     DO  m = 1, bc_h(1)%ns
-       i = bc_h(1)%i(m)            
-       j = bc_h(1)%j(m)
-       k = bc_h(1)%k(m)
-       w(k+1,j,i) = 0.0_wp
+       ic = bc_h(1)%i(m)            
+       jc = bc_h(1)%j(m)
+       kc = bc_h(1)%k(m)
+       w(kc+1,jc,ic) = 0.0_wp
     ENDDO
 !
@@ -4592,14 +4644,14 @@
        IF ( ibc_pt_b == 1 )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)            
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             pt(k-1,j,i) = pt(k,j,i)
+             ic = bc_h(0)%i(m)            
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             pt(kc-1,jc,ic) = pt(kc,jc,ic)
           ENDDO
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)            
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             pt(k+1,j,i) = pt(k,j,i)
+             ic = bc_h(1)%i(m)            
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+             pt(kc+1,jc,ic) = pt(kc,jc,ic)
           ENDDO   
        ENDIF
@@ -4610,31 +4662,31 @@
        IF ( ibc_q_b == 1 )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)            
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             q(k-1,j,i) = q(k,j,i)
+             ic = bc_h(0)%i(m)            
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             q(kc-1,jc,ic) = q(kc,jc,ic)
           ENDDO  
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)            
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             q(k+1,j,i) = q(k,j,i)
+             ic = bc_h(1)%i(m)            
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+             q(kc+1,jc,ic) = q(kc,jc,ic)
           ENDDO  
        ENDIF
        IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)            
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             nc(k-1,j,i) = 0.0_wp
-             qc(k-1,j,i) = 0.0_wp
+             ic = bc_h(0)%i(m)            
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             nc(kc-1,jc,ic) = 0.0_wp
+             qc(kc-1,jc,ic) = 0.0_wp
           ENDDO  
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)            
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-
-             nc(k+1,j,i) = 0.0_wp
-             qc(k+1,j,i) = 0.0_wp
+             ic = bc_h(1)%i(m)            
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+
+             nc(kc+1,jc,ic) = 0.0_wp
+             qc(kc+1,jc,ic) = 0.0_wp
           ENDDO  
        ENDIF
@@ -4642,16 +4694,16 @@
        IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)            
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             nr(k-1,j,i) = 0.0_wp
-             qr(k-1,j,i) = 0.0_wp
+             ic = bc_h(0)%i(m)            
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             nr(kc-1,jc,ic) = 0.0_wp
+             qr(kc-1,jc,ic) = 0.0_wp
           ENDDO  
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)            
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             nr(k+1,j,i) = 0.0_wp
-             qr(k+1,j,i) = 0.0_wp
+             ic = bc_h(1)%i(m)            
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+             nr(kc+1,jc,ic) = 0.0_wp
+             qr(kc+1,jc,ic) = 0.0_wp
           ENDDO  
        ENDIF
@@ -4663,14 +4715,14 @@
        IF ( ibc_s_b == 1 )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)            
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             s(k-1,j,i) = s(k,j,i)
+             ic = bc_h(0)%i(m)            
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             s(kc-1,jc,ic) = s(kc,jc,ic)
           ENDDO 
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)            
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             s(k+1,j,i) = s(k,j,i)
+             ic = bc_h(1)%i(m)            
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+             s(kc+1,jc,ic) = s(kc,jc,ic)
           ENDDO  
        ENDIF
@@ -4682,14 +4734,14 @@
           DO  n = 1, nspec
              DO  m = 1, bc_h(0)%ns
-                i = bc_h(0)%i(m)            
-                j = bc_h(0)%j(m)
-                k = bc_h(0)%k(m)
-                chem_species(n)%conc(k-1,j,i) = chem_species(n)%conc(k,j,i)
+                ic = bc_h(0)%i(m)            
+                jc = bc_h(0)%j(m)
+                kc = bc_h(0)%k(m)
+                chem_species(n)%conc(kc-1,jc,ic) = chem_species(n)%conc(kc,jc,ic)
              ENDDO 
              DO  m = 1, bc_h(1)%ns
-                i = bc_h(1)%i(m)            
-                j = bc_h(1)%j(m)
-                k = bc_h(1)%k(m)
-                chem_species(n)%conc(k+1,j,i) = chem_species(n)%conc(k,j,i)
+                ic = bc_h(1)%i(m)            
+                jc = bc_h(1)%j(m)
+                kc = bc_h(1)%k(m)
+                chem_species(n)%conc(kc+1,jc,ic) = chem_species(n)%conc(kc,jc,ic)
              ENDDO
           ENDDO
@@ -4701,32 +4753,32 @@
        IF ( ibc_salsa_b == 1 )  THEN
           DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             DO  ib = 1, nbins_aerosol
-                aerosol_number(ib)%conc(k-1,j,i) = aerosol_number(ib)%conc(k,j,i)
+             ic = bc_h(0)%i(m)
+             jc = bc_h(0)%j(m)
+             kc = bc_h(0)%k(m)
+             DO  lb = 1, nbins_aerosol
+                aerosol_number(lb)%conc(kc-1,jc,ic) = aerosol_number(lb)%conc(kc,jc,ic)
              ENDDO
-             DO  ic = 1, nbins_aerosol * ncomponents_mass
-                aerosol_mass(ic)%conc(k-1,j,i) = aerosol_mass(ic)%conc(k,j,i)
+             DO  lc = 1, nbins_aerosol * ncomponents_mass
+                aerosol_mass(lc)%conc(kc-1,jc,ic) = aerosol_mass(lc)%conc(kc,jc,ic)
              ENDDO
              IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  ig = 1, ngases_salsa
-                   salsa_gas(ig)%conc(k-1,j,i) = salsa_gas(ig)%conc(k,j,i)
+                DO  lg = 1, ngases_salsa
+                   salsa_gas(lg)%conc(kc-1,jc,ic) = salsa_gas(lg)%conc(kc,jc,ic)
                 ENDDO
              ENDIF
           ENDDO
           DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             DO  ib = 1, nbins_aerosol
-                aerosol_number(ib)%conc(k+1,j,i) = aerosol_number(ib)%conc(k,j,i)
+             ic = bc_h(1)%i(m)
+             jc = bc_h(1)%j(m)
+             kc = bc_h(1)%k(m)
+             DO  lb = 1, nbins_aerosol
+                aerosol_number(lb)%conc(kc+1,jc,ic) = aerosol_number(lb)%conc(kc,jc,ic)
              ENDDO
-             DO  ic = 1, nbins_aerosol * ncomponents_mass
-                aerosol_mass(ic)%conc(k+1,j,i) = aerosol_mass(ic)%conc(k,j,i)
+             DO  lc = 1, nbins_aerosol * ncomponents_mass
+                aerosol_mass(lc)%conc(kc+1,jc,ic) = aerosol_mass(lc)%conc(kc,jc,ic)
              ENDDO
              IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  ig = 1, ngases_salsa
-                   salsa_gas(ig)%conc(k+1,j,i) = salsa_gas(ig)%conc(k,j,i)
+                DO  lg = 1, ngases_salsa
+                   salsa_gas(lg)%conc(kc+1,jc,ic) = salsa_gas(lg)%conc(kc,jc,ic)
                 ENDDO
              ENDIF
@@ -4736,5 +4788,4 @@
 
  END SUBROUTINE pmci_boundary_conds
-
-
+   
 END MODULE pmc_interface
